package dictionary_admin

import (
	"context"
	"git.noahlan.cn/n-admin/n-admin-server/rpc/core/types/core"
	"github.com/jinzhu/copier"

	"git.noahlan.cn/n-admin/n-admin-server/api/internal/svc"
	"git.noahlan.cn/n-admin/n-admin-server/api/internal/types"

	"net/http"
)

type CreateDictionaryAdminLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	r      *http.Request
}

func NewCreateDictionaryAdminLogic(r *http.Request, ctx context.Context, svcCtx *svc.ServiceContext) *CreateDictionaryAdminLogic {
	return &CreateDictionaryAdminLogic{
		r:      r,
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *CreateDictionaryAdminLogic) CreateDictionaryAdmin(req *types.DictionaryInfo) (resp *types.BaseID, err error) {
	var rpcReq core.DictionaryInfo
	_ = copier.Copy(&rpcReq, req)

	rpcResp, err := l.svcCtx.CoreRpc.CreateDictionary(l.ctx, &rpcReq)
	if err != nil {
		return nil, err
	}
	resp = &types.BaseID{ID: rpcResp.ID}
	return
}
